org.apache.commons.math3.distribution

## Class HypergeometricDistribution

- java.lang.Object
- - org.apache.commons.math3.distribution.AbstractIntegerDistribution
  - - org.apache.commons.math3.distribution.HypergeometricDistribution

All Implemented Interfaces:
  Serializable, IntegerDistribution

    public class HypergeometricDistribution
    extends AbstractIntegerDistribution

Implementation of the hypergeometric distribution.

Version:
  $Id: HypergeometricDistribution.java 1416643 2012-12-03 19:37:14Z tn $
See Also:
  Hypergeometric distribution (Wikipedia), Hypergeometric distribution (MathWorld), Serialized Form

### Field Summary

Fields
`private int` `numberOfSuccesses` The number of successes in the population.
`private double` `numericalVariance` Cached numerical variance
`private boolean` `numericalVarianceIsCalculated` Whether or not the numerical variance has been calculated
`private int` `populationSize` The population size.
`private int` `sampleSize` The sample size.
`private static long` `serialVersionUID` Serializable version identifier.

### Fields inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

`random, randomData`

### Constructor Summary

Constructors
Constructor and Description
`HypergeometricDistribution(int populationSize, int numberOfSuccesses, int sampleSize)` Construct a new hypergeometric distribution with the specified population size, number of successes in the population, and sample size.
`HypergeometricDistribution(RandomGenerator rng, int populationSize, int numberOfSuccesses, int sampleSize)` Creates a new hypergeometric distribution.

### Method Summary

Methods
`protected double` `calculateNumericalVariance()` Used by `getNumericalVariance()`.
`double` `cumulativeProbability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`private int[]` `getDomain(int n, int m, int k)` Return the domain for the given hypergeometric distribution parameters.
`private int` `getLowerDomain(int n, int m, int k)` Return the lowest domain value for the given hypergeometric distribution parameters.
`int` `getNumberOfSuccesses()` Access the number of successes.
`double` `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
`double` `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
`int` `getPopulationSize()` Access the population size.
`int` `getSampleSize()` Access the sample size.
`int` `getSupportLowerBound()` Access the lower bound of the support.
`int` `getSupportUpperBound()` Access the upper bound of the support.
`private int` `getUpperDomain(int m, int k)` Return the highest domain value for the given hypergeometric distribution parameters.
`private double` `innerCumulativeProbability(int x0, int x1, int dx)` For this distribution, `X`, this method returns `P(x0 <= X <= x1)`.
`boolean` `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
`double` `probability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`.
`double` `upperCumulativeProbability(int x)` For this distribution, `X`, this method returns `P(X >= x)`.

### Methods inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

`cumulativeProbability, inverseCumulativeProbability, reseedRandomGenerator, sample, sample, solveInverseCumulativeProbability`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### serialVersionUID

    private static final long serialVersionUID

Serializable version identifier.

See Also:
  Constant Field Values

#### numberOfSuccesses

    private final int numberOfSuccesses

The number of successes in the population.

#### populationSize

    private final int populationSize

The population size.

#### sampleSize

    private final int sampleSize

The sample size.

#### numericalVariance

    private double numericalVariance

Cached numerical variance

#### numericalVarianceIsCalculated

    private boolean numericalVarianceIsCalculated

Whether or not the numerical variance has been calculated

### Constructor Detail

#### HypergeometricDistribution

    public HypergeometricDistribution(int populationSize,
                              int numberOfSuccesses,
                              int sampleSize)
                               throws NotPositiveException,
                                      NotStrictlyPositiveException,
                                      NumberIsTooLargeException

Construct a new hypergeometric distribution with the specified population size, number of successes in the population, and sample size.

Parameters:
  `populationSize` - Population size.
  `numberOfSuccesses` - Number of successes in the population.
  `sampleSize` - Sample size.
Throws:
  `NotPositiveException` - if `numberOfSuccesses < 0`.
  `NotStrictlyPositiveException` - if `populationSize <= 0`.
  `NumberIsTooLargeException` - if `numberOfSuccesses > populationSize`, or `sampleSize > populationSize`.

#### HypergeometricDistribution

    public HypergeometricDistribution(RandomGenerator rng,
                              int populationSize,
                              int numberOfSuccesses,
                              int sampleSize)
                               throws NotPositiveException,
                                      NotStrictlyPositiveException,
                                      NumberIsTooLargeException

Creates a new hypergeometric distribution.

Parameters:
  `rng` - Random number generator.
  `populationSize` - Population size.
  `numberOfSuccesses` - Number of successes in the population.
  `sampleSize` - Sample size.
Throws:
  `NotPositiveException` - if `numberOfSuccesses < 0`.
  `NotStrictlyPositiveException` - if `populationSize <= 0`.
  `NumberIsTooLargeException` - if `numberOfSuccesses > populationSize`, or `sampleSize > populationSize`.
Since:
  3.1

### Method Detail

#### cumulativeProbability

    public double cumulativeProbability(int x)

For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

#### getDomain

    private int[] getDomain(int n,
                  int m,
                  int k)

Return the domain for the given hypergeometric distribution parameters.

Parameters:
  `n` - Population size.
  `m` - Number of successes in the population.
  `k` - Sample size.
Returns:
  a two element array containing the lower and upper bounds of the hypergeometric distribution.

#### getLowerDomain

    private int getLowerDomain(int n,
                     int m,
                     int k)

Return the lowest domain value for the given hypergeometric distribution parameters.

Parameters:
  `n` - Population size.
  `m` - Number of successes in the population.
  `k` - Sample size.
Returns:
  the lowest domain value of the hypergeometric distribution.

#### getNumberOfSuccesses

    public int getNumberOfSuccesses()

Access the number of successes.

Returns:
  the number of successes.

#### getPopulationSize

    public int getPopulationSize()

Access the population size.

Returns:
  the population size.

#### getSampleSize

    public int getSampleSize()

Access the sample size.

Returns:
  the sample size.

#### getUpperDomain

    private int getUpperDomain(int m,
                     int k)

Return the highest domain value for the given hypergeometric distribution parameters.

Parameters:
  `m` - Number of successes in the population.
  `k` - Sample size.
Returns:
  the highest domain value of the hypergeometric distribution.

#### probability

    public double probability(int x)

For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`. In other words, this method represents the probability mass function (PMF) for the distribution.

Parameters:
  `x` - the point at which the PMF is evaluated
Returns:
  the value of the probability mass function at `x`

#### upperCumulativeProbability

    public double upperCumulativeProbability(int x)

For this distribution, `X`, this method returns `P(X >= x)`.

Parameters:
  `x` - Value at which the CDF is evaluated.
Returns:
  the upper tail CDF for this distribution.
Since:
  1.1

#### innerCumulativeProbability

    private double innerCumulativeProbability(int x0,
                                    int x1,
                                    int dx)

For this distribution, `X`, this method returns `P(x0 <= X <= x1)`. This probability is computed by summing the point probabilities for the values `x0, x0 + 1, x0 + 2, ..., x1`, in the order directed by `dx`.

Parameters:
  `x0` - Inclusive lower bound.
  `x1` - Inclusive upper bound.
  `dx` - Direction of summation (1 indicates summing from x0 to x1, and 0 indicates summing from x1 to x0).
Returns:
  `P(x0 <= X <= x1)`.

#### getNumericalMean

    public double getNumericalMean()

Use this method to get the numerical value of the mean of this distribution. For population size `N`, number of successes `m`, and sample size `n`, the mean is `n * m / N`.

Returns:
  the mean or `Double.NaN` if it is not defined

#### getNumericalVariance

    public double getNumericalVariance()

Use this method to get the numerical value of the variance of this distribution. For population size `N`, number of successes `m`, and sample size `n`, the variance is `[n * m * (N - n) * (N - m)] / [N^2 * (N - 1)]`.

Returns:
  the variance (possibly `Double.POSITIVE_INFINITY` or `Double.NaN` if it is not defined)

#### calculateNumericalVariance

    protected double calculateNumericalVariance()

Used by `getNumericalVariance()`.

Returns:
  the variance of this distribution

#### getSupportLowerBound

    public int getSupportLowerBound()

Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in Z | P(X <= x) > 0}`.

For population size `N`, number of successes `m`, and sample size `n`, the lower bound of the support is `max(0, n + m - N)`.

Returns:
  lower bound of the support

#### getSupportUpperBound

    public int getSupportUpperBound()

Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X <= x) = 1}`.

For number of successes `m` and sample size `n`, the upper bound of the support is `min(m, n)`.

Returns:
  upper bound of the support

#### isSupportConnected

    public boolean isSupportConnected()

Use this method to get information about whether the support is connected, i.e. whether all integers between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

Returns:
  `true`